
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>.NET 数据访问架构指南(二) / iVAN</title>

    <meta name="description" content=".NET 数据访问架构指南(二) 访问|架构|数据 使用自动化事务 自动化事务简化了编程模型,因为它们不需要明确地开始新事务处理过程,或明确执行或取消事务.然而,自动化事务的最大优点是它们能与DTC结合起来,这就使单个事务可以扩展到多个分布式数据源中.在大型分布式应用程序中,这个优点是很重要的.尽管通过手工对DTC直接编程来控制分布式事务是可能的,但自动化事务处理极大的简化了工作量,并且它是为基于组件的系统而设计的.例如,可以方便地以说明方式配置多个组件以执行包含了单个事务处理的任务. 自动化事务依赖于COM+提供的分布式事务处">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">.NET 数据访问架构指南(二)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>访问|架构|数据</p>
<p>使用自动化事务</p>
<p>自动化事务简化了编程模型，因为它们不需要明确地开始新事务处理过程，或明确执行或取消事务。然而，自动化事务的最大优点是它们能与DTC结合起来，这就使单个事务可以扩展到多个分布式数据源中。在大型分布式应用程序中，这个优点是很重要的。尽管通过手工对DTC直接编程来控制分布式事务是可能的，但自动化事务处理极大的简化了工作量，并且它是为基于组件的系统而设计的。例如，可以方便地以说明方式配置多个组件以执行包含了单个事务处理的任务。</p>
<p>自动化事务依赖于COM+提供的分布式事务处理支持特性。结果，只有服务组件（即从ServicedComponent类中派生的组件）能够使用自动化事务。</p>
<p>要为自动化事务处理配置类，操作如下：</p>
<p>从位于EnterpriseServices名称空间的ServicedComponent类中派生新类。 <br />通过Transaction属性定义类的事务处理需求。来自TransactionOption的枚举值决定了如何在COM+类中配置类。可与此属性一同设置的其它属性包括事务处理分离等级和超时上限。 <br />为了避免必须明确选出事务处理结果，可以用AutoComplete属性对方法进行注释。如果这些方法释放异常，事务将自动取消。注意，如果需要，仍可以直接挑选事务处理结果。更多详情，见本文稍后确定事务处理结果的节。 <br />更多信息</p>
<p>关于COM+自动化事务的更多信息，可在平台SDK文档中搜索“通过COM+的自动化事务”获取。 <br />关于.NE T事务处理类的示例，见附录中的如何编码.NET事务处理。 <br />配置事务处理分离级别</p>
<p>用于COM+1.0版--即运行在Windows 2000中的COM+--的事务处理分离级别被序列化了。这样做提供了最高的分离等级，却是以性能为代价的。系统的整体吞吐量被降低了。因为所涉及到的资源管理器（典型地是数据库）在事务处理期间必须保持读和写锁。在此期间，其它所有事务处理都被阻断了，这种情况将对应用程序的扩展能力产生极大冲击。</p>
<p>随微软Windows .NET发行的COM+ 1.5版允许有COM+目录中按组件配置事务处理分离等级。与事务中根组件相关的设置决定了事务处理的分离等级。另外，同一事务流中的内部子组件拥有的事务处理等级必须不能高于要组件所定义的等级。如果不是这样，当子组件实例化时，将导致错误。</p>
<p>对.NET管理类，Transaction属性支持所有的公有Isolation属性。你可以用此属性陈述式地指定一特殊分离等级，如下面的代码所示：</p>
<p>[Transaction(TransactionOption.Supported, Isolation=TransactionIsolationLevel.ReadCommitted)]<br />public class Account : ServicedComponent<br />{<br />  . . .<br />}</p>
<p>更多信息</p>
<p>关于配置事务处理分离等级及其它Windows .NET COM+增强特性的更多信息，见MSDN杂志2001年8月期的“Windows XP：利用COM+ 1.5的增强特性使你的组件更强壮”一文。</p>
<p>确定事务处理结果</p>
<p>在单个事务流的所有事务处理组件上下文中，自动化事务处理结果由事务取消标志和一致性标志的状态决定。当事务流中的根组件成为非活动状态（并且控制权返回调用者）时，确定事务处理结果。这种情况在图5中得到了演示，此图显示的是一个典型的银行基金传送事务。</p>
<p>图5 事务流上下文</p>
<p>当根对象（在本例中是对象）变为非活动状态，并且客户的方法调用返回时，确定事务处理结果。在任何上下文中的任何一致性标志被设为假，或如果事务处理取消标志设为真，那么底层的物理DTC事务将被取消。</p>
<p>可以以下面两种方式之一从.NET对象中控制事务处理结果：</p>
<p>可以用AutoComplete属性对方法进行注释，并让.NET自动存放将决定事务处理结果投票。如果方法释放异常，利用此属性，一致性标志自动地被设为假（此值最终使事务取消）。如果方法返回而没有释放异常，那么一致性标志将设为真，此值指出组件乐于执行事务。这并没有得到保证，因为它依赖于同一事务流中其它对象的投票。 <br />可以调用ContextUtil类的静态方法SetComplete或 SetAbort，这些方法分别将一致性标志设为真或假。 <br />严重性大于10的SQL Server错误将导致管理数据供应器释放SqlException类型的异常。如果方法缓存并处理异常，就要确保或者通过手工取消了事务，或者方法被标记了[AutoComplete]，以保证异常能传递回调用者。</p>
<p>AutoComplete方法</p>
<p>对于标记了属性的方法，执行下面操作：</p>
<p>将SqlException传递加调用堆栈。 <br />将SqlException封装在外部例外中，并传递回调用者。也可以将异常封装在对调用者更有意义的异常类型中。 <br />异常如果不能传递，将导致对象不会提出取消事务，从而忽视数据库错误。这意味着共享同一事务流的其它对象的成功操作将被提交。</p>
<p>下面的代码缓存了SqlException，然后将它直接传递回调用者。事务处理最终将被取消，因为对象的一致性标志在对象变为非活动状态时自动被设为假。</p>
<p>[AutoComplete]<br />void SomeMethod()<br />{<br />  try<br />  {<br />    // Open the connection, and perform database operation<br />    . . .<br />  }<br />  catch (SqlException sqlex )<br />  {<br />    LogException( sqlex ); // Log the exception details<br />    throw;                 // Rethrow the exception, causing the consistent <br />                           // flag to be set to false.<br />  }<br />  finally<br />  {<br />    // Close the database connection<br />    . . .<br />  }<br />}</p>
<p>Non-AutoComlete方法</p>
<p>对于没有AutoComplete的属性的方法，必须：</p>
<p>在catch块内调用ContextUtil.SetAbort以终止事务处理。这就将相容标志设置为假。 <br />如果没有发生异常事件，调用ContextUtil.SetComplete，以提交事务，这就将相容标志设置为真（缺省状态）。 <br />代码说明了这种方法。</p>
<p>void SomeOtherMethod()<br />{<br />  try<br />  {<br />    // Open the connection, and perform database operation<br />    . . .<br />    ContextUtil.SetComplete(); // Manually vote to commit the transaction<br />  }<br />  catch (SqlException sqlex)<br />  {<br />    LogException( sqlex );   // Log the exception details<br />    ContextUtil.SetAbort();  // Manually vote to abort the transaction<br />    // Exception is handled at this point and is not propagated to the caller<br />  }<br />  finally<br />  {<br />    // Close the database connection<br />    . . .<br />  }<br />}</p>
<p>注意 如果有多个catch块，在方法开始的时候调用ContextVtil.SetAbort，以及在try块的末尾调用ContextUtil.SetComplete都会变得容易。用这种方法，就不需要在每个catch块中重复调用ContextUtil.SetAbort。通过这种方法确定的相容标志的设置只在方法返回时有效。</p>
<p>对于异常事件（或循环异常），必须把它传递到调用堆栈中，因为这使得调用代码认为事务处理失败。它允许调用代码做出优化选择。比如，在银行资金转账中，如果债务操作失败，则转帐分支可以决定不执行债务操作。</p>
<p>如果把相容标志设置为假并且在返回时没有出现异常事件，则调用代码就没有办法知道事务处理是否一定失败。虽然可以返回Boolean值或设置Boolean输出参数，但还是应该前后一致，通过显示异常事件以表明有错误发生。这样代码就有一种标准的错误处理方法，因此更简明、更具有相容性。</p>
<p>数据分页</p>
<p>在分布式应用程序中利用数据进行分页是一项普遍的要求。比如，用户可能得到书的列表而该列表又不能够一次完全显示，用户就需要在数据上执行一些熟悉的操作，比如浏览下一页或上一页的数据，或者跳到列表的第一页或最后一页。</p>
<p>这部分内容将讨论实现这种功能的选项，以及每种选项在性能和缩放性上的效果。</p>
<p>选项比较</p>
<p>数据分页的选项有：</p>
<p>利用SqlDataAdapter的Fill方法，将来自查询处的结果填充到DataSet中。 <br />通过COM的可相互操作性使用ADO，并利用服务器光标。 <br />利用存储的过程手工实现数据分页。 <br />对数据进行分页的最优选项依赖于下列因素：</p>
<p>扩展性要求 <br />性能要求 <br />网络带宽 <br />数据库服务器的存储器和功率 <br />中级服务器的存储器和功率 <br />由分页查询所返回的行数 <br />数据总页数的大小 <br />性能测试表明利用存储过程的手工方法在很大的应力水平范围上都提供了最佳性能。然而，由于手工方法在服务器上执行工作，如果大部分站点功能都依赖数据分页功能，那么服务器性能就会成一个关键要素。为确保这种方法能适合特殊环境，应该测试各种特殊要求的选项。</p>
<p>下面将讨论各种不同的选项。</p>
<p>使用SqlDataAdapter</p>
<p>如前面所讨论的，SqlDataAdapter是用来把来自数据库的数据填充到DataSet中，过载的Fill方法中的任一个都需要两个整数索引值（如下列代码所示）：</p>
<p>public int Fill(<br />   DataSet dataSet,<br />   int startRecord,<br />   int maxRecords,<br />   string srcTable<br />);<br />StartRecord值标示从零开始的记录起始索引值。MaxRecord值表示从startRecord开始的记录数，并将拷贝到新的DataSet中。</p>
<p>SqlDataAdapter在内部利用SqlDataReader执行查询并返回结果。SqlDataAdapter读取结果并创建基于来自SalDataReader的数据的Dataset。SqlDataAdapter通过startRecord和maxRecords把所有结果都拷贝到新生成的DataSet中，并丢弃不需要的数据。这意味着许多不必要的数据将潜在的通过网络进入数据访问客户--这是这种方法的主要缺陷。</p>
<p>比如，如果有1000个记录，而需要的是第900到950个记录，那么前面的899个记录将仍然穿越网络然后被丢弃。对于小数量的记录，这种开销可能是比较小的，但如果针对大量数据的分页，则这种开销就会非常巨大。</p>
<p>使用ADO</p>
<p>实现分页的另一个选项是利用基于COM的ADO进行分页。这种方法的目标是获得访问服务器光标。服务器光标通过ADO Recordset对象显示。可以把Recordset光标的位置设置到adUseServer中。如果你的OLE DB供应器支持这种设置（如SQLOLEDB那样），就可以使用服务器光标。这样就可以利用光标直接导航到起始记录，而不需要将所有数据传过网络进入访问数据的用户代码中。</p>
<p>这种方法有下面两个缺点：</p>
<p>在大多数情况下，可能需要将返回到Recordset对象中的记录翻译成DataSet中的内容，以便在客户管理的代码中使用。虽然OleDbDataAdapter确实在获取ADO Recordset对象并把它翻译成Dataset时过载了Fill方法，但是并没有利用特殊记录进行开始与结束操作的功能。唯一现实的选项是把开始记录移动到Recordset对象中，循环每个记录，然后手工拷贝数据到手工生成的新Dataset中。这种操作，尤其是利用COM Interop调用，其优点可能不仅仅是不需要在网络上传输多余的数据，尤其对于小的DataSet更明显。 <br />从服务器输出所需数据时，将保持连接和服务器光标开放。在数据库服务器上，光标的开放与维护需要昂贵的资源。虽然该选项提高了性能，但是由于为延长的时间两消耗服务器资源，从而也有可能降低可扩展性。 <br />提供手工实现</p>
<p>在本部分中讨论的数据分页的最后一个选项是利用存储过程手工实现应用程序的分页功能。对于包含唯一关键字的表格，实现存储过程相对容易一些。而对于没有唯一关键字的表格（也不应该有许多关键字），该过程会相对复杂一些。</p>
<p>带有唯一关键字的表格的分页</p>
<p>如果表格包含一个唯一关键字，就可以利用WHERE条款中的关键字创建从某个特殊行起始的结果设置。这种方法，与用来限制结果设置大小的SET ROWCOUNT状态是相匹配的，提供了一种有效的分页原理。这一方法将在下面存储的代码中说明：</p>
<p>CREATE PROCEDURE GetProductsPaged<br />@lastProductID int,<br />@pageSize int<br />AS<br />SET ROWCOUNT @pageSize<br />SELECT *<br />FROM Products<br />WHERE [standard search criteria]<br />AND ProductID &gt; @lastProductID<br />ORDER BY [Criteria that leaves ProductID monotonically increasing]<br />GO</p>
<p>这个存储过程的调用程序仅仅维护LastProductID的值，并通过所选的连续调用之间的页的大小增加或减小该值。</p>
<p>不带有唯一关键字的表格的分页</p>
<p>如果需要分页的表格没有唯一关键字，可以考虑添加一个--比如利用标识栏。这样就可以实现上面讨论的分页方案了。</p>
<p>只要能够通过结合结果记录中的两个或更多区域来产生唯一性，就仍然有可能实现无唯一关键字表格的有效分页方案。</p>
<p>比如，考察下列表格： Col1 Col2 Col3 Other columns… <br />A 1 W … <br />A 1 X   . <br />A 1 Y   . <br />A 1 Z   . <br />A 2 W   . <br />A 2 X   . <br />B 1 W … <br />B 1 X   .</p>
<p>对于该表，结合Col 、Col2 和Col3就可能产生一种唯一性。这样，就可以利用下面存储过程中的方法实现分布原理：</p>
<p>CREATE PROCEDURE RetrieveDataPaged<br />@lastKey char(40),<br />@pageSize int<br />AS<br />SET ROWCOUNT @pageSize<br />SELECT<br />Col1, Col2, Col3, Col4, Col1+Col2+Col3 As KeyField<br />FROM SampleTable<br />WHERE [Standard search criteria]<br />AND Col1+Col2+Col3 &gt; @lastKey<br />ORDER BY Col1 ASC, Col2 ASC, Col3 ASC<br />GO</p>
<p>客户保持存储过程返回的keyField栏的最后值，然后又插入回到存储过程中以控制表的分页。</p>
<p>虽然手工实现增加了数据库服务器上的应变，但它避免了在网络上传输不必要的数据。性能测试表明在整个应变水平中这种方法都工作良好。然而，根据站点工作所涉及的数据分页功能的多少，在服务器上进行手工分页可能影响应用程序的可扩展性。应该在所在环境中运行性能测试，为应用程序找到最合适的方法。</p>
<p>附录</p>
<p>如何为一个.NET类启用对象结构</p>
<p>要利用Enterprise (COM+)Services为对象结构启用.NET管理的类，需要执行下列步骤：</p>
<p>从位于System. Enterprise Services名字空间中的Serviced Component中导出所需类。 <br />using System.EnterpriseServices;<br />public class DataAccessComponent : ServicedComponent<br />为该类添加Construction Enabled属性，并合理地指定缺省结构字符串，该缺省值保存在COM+目录中，管理员可以利用组件服务微软管理控制台（MNC）的snap-in来维护该缺省值。 <br />[ConstructionEnabled(Default="default DSN")]<br />public class DataAccessComponent : ServicedComponent<br />提供虚拟Construct方法的替换实现方案。该方法在对象语言构造程序之后调用。在COM目录中保存的结构字符串是该方法的唯一字符串。 <br />public override void Construct( string constructString )<br />{<br />  // Construct method is called next after constructor.<br />  // The configured DSN is supplied as the single argument<br />}<br />通过Assembly key文件或Assembly key Name属性为该汇编提供一个强名字。任何用COM+服务注册的汇编必须有一个强名字。关于带有强名字汇编的更多信息，参考：http://msdn.microsoft.com/library/en-us/cpguide/html/cpconworkingwithstrongly- namedassemblies.Asp。 <br />[assembly: AssemblyKeyFile("DataServices.snk")]<br />为支持动态注册，可以利用汇编层上的属性ApplicationName和Application Action分别指定用于保持汇编元素和应用程序动作类型的COM+应用程序的名字。关于汇编注册的更多信息，参考： http://msdn.microsoft.com/library/en-us/cpguide/html/cpconregisteringserviced components.asp。 <br />// the ApplicationName attribute specifies the name of the<br />// COM+ Application which will hold assembly components<br />[assembly : ApplicationName("DataServices")]</p>
<p>// the ApplicationActivation.ActivationOption attribute specifies <br />// where assembly components are loaded on activation<br />// Library : components run in the creator's process<br />// Server : components run in a system process, dllhost.exe<br />[assembly: ApplicationActivation(ActivationOption.Library)]<br />下列代码段是一个叫做DataAccessComponent的服务组件，它利用COM+结构字符串来获得数据库连接字符串。</p>
<p>using System;<br />using System.EnterpriseServices;</p>
<p>// the ApplicationName attribute specifies the name of the<br />// COM+ Application which will hold assembly components<br />[assembly : ApplicationName("DataServices")]</p>
<p>// the ApplicationActivation.ActivationOption attribute specifies <br />// where assembly components are loaded on activation<br />// Library : components run in the creator's process<br />// Server : components run in a system process, dllhost.exe<br />[assembly: ApplicationActivation(ActivationOption.Library)]</p>
<p>// Sign the assembly. The snk key file is created using the <br />// sn.exe utility<br />[assembly: AssemblyKeyFile("DataServices.snk")]</p>
<p>[ConstructionEnabled(Default="Default DSN")]<br />public class DataAccessComponent : ServicedComponent<br />{<br />    private string connectionString;<br />    public DataAccessComponent()<br />    {<br />      // constructor is called on instance creation<br />    }<br />    public override void Construct( string constructString )<br />    {<br />      // Construct method is called next after constructor.<br />      // The configured DSN is supplied as the single argument<br />      this.connectionString = constructString;<br />    }<br />}<br />如何利用SqlDataAdapter来检索多个行</p>
<p>下面的代码说明如何利用SqlDataAdapter对象发出一个生成Data Set或Datatable的命令。它从SQL Server Northwind数据库中检索一系列产品目录。</p>
<p>using System.Data;<br />using System.Data.SqlClient;</p>
<p>public DataTable RetrieveRowsWithDataTable()<br />{<br />  using ( SqlConnection conn = new SqlConnection(connectionString) )<br />  {<br />    SqlCommand cmd = new SqlCommand("DATRetrieveProducts", conn);<br />    cmd.CommandType = CommandType.StoredProcedure;<br />    SqlDataAdapter da = new SqlDataAdapter( cmd );<br />    DataTable dt = new DataTable("Products");<br />    da.Fill(dt);<br />    return dt;<br />  }<br />}<br />按下列步骤利用SqlAdapter生成DataSet或DataTable：</p>
<p>创建SqlCommand对象启用存储过程，并把它与SqlConnection对象（显示的）或连接字符串（未显示）相联系。 <br />创建一个新的SqlDataAdapter对象，并把它SqlCommand对象相联系。 <br />创建DataTable(或者DataSet)对象。利用构造程序自变量命名DataTable. <br />调用SqlData Adapter对象的Fill方法，把检索的行转移到DataSet或Datatable中。 <br />如何利用SqlDataReader检索多个行</p>
<p>下列代码说明了如何利用SqlDataReader方法检索多行：</p>
<p>using System.IO;<br />using System.Data;<br />using System.Data.SqlClient;</p>
<p>public SqlDataReader RetrieveRowsWithDataReader()<br />{<br />  SqlConnection conn = new SqlConnection(<br />         "server=(local);Integrated Security=SSPI;database=northwind");<br />  SqlCommand cmd = new SqlCommand("DATRetrieveProducts", conn );<br />  cmd.CommandType = CommandType.StoredProcedure;<br />  try<br />  {<br />    conn.Open();<br />    // Generate the reader. CommandBehavior.CloseConnection causes the<br />    // the connection to be closed when the reader object is closed<br />    return( cmd.ExecuteReader( CommandBehavior.CloseConnection ) );<br />  }<br />  catch<br />  {<br />    conn.Close();<br />    throw;<br />  }<br />}</p>
<p>// Display the product list using the console<br />private void DisplayProducts()<br />{<br />  SqlDataReader reader = RetrieveRowsWithDataReader();<br />  while (reader.Read())<br />  {<br />    Console.WriteLine("{0} {1} {2}", <br />                      reader.GetInt32(0).ToString(), <br />                      reader.GetString(1) );<br />  }<br />  reader.Close(); // Also closes the connection due to the<br />                  // CommandBehavior enum used when generating the reader<br />}<br />按下列步骤利用SqlDataReader检索多行：</p>
<p>创建用于执行存储的过程的SqlCommand对象，并把它与SqlConnection对象相联系。 <br />打开链接。 <br />通过调用SqlCommand对象的Excute Reader方法生成SqlDataReader对象。 <br />从流中读取数据，调用SqlDataReader对象的Read方法来检索行，并利用分类的存取程序方法（如GetIut 32和Get String方法）检索列的值。 <br />完成读取后，调用Close方法。 <br />如何利用XmlReader检索多个行</p>
<p>可以利用SqlCommand对象生成XmlReader对象，它提供对XML数据的基于流的前向访问。该命令（通常是一个存储的过程）必须生成一个基于XML的结果设置，它对于SQL Server2000通常是由带有有效条款FOR XML的SELECT状态组成。下列代码段说明了这种方法：</p>
<p>public void RetrieveAndDisplayRowsWithXmlReader()<br />{<br />  SqlConnection conn = new SqlConnection(connectionString);<br />  SqlCommand cmd = new SqlCommand("DATRetrieveProductsXML", conn );<br />  cmd.CommandType = CommandType.StoredProcedure;<br />  try<br />  {<br />    conn.Open();<br />    XmlTextReader xreader = (XmlTextReader)cmd.ExecuteXmlReader();<br />    while ( xreader.Read() )<br />    {<br />      if ( xreader.Name == "PRODUCTS" ) <br />      {<br />        string strOutput = xreader.GetAttribute("ProductID");<br />        strOutput += " ";<br />        strOutput += xreader.GetAttribute("ProductName");<br />        Console.WriteLine( strOutput );<br />      }<br />    }<br />    xreader.Close();  <br />  }<br />  catch<br />  {<br />    throw;<br />  }<br />  finally<br />  {<br />    conn.Close();<br />  }<br />}<br />上述代码使用了下列存储过程：</p>
<p>CREATE PROCEDURE DATRetrieveProductsXML<br />AS<br />SELECT * FROM PRODUCTS <br />FOR XML AUTO<br />GO<br />按下列步骤检索XML数据：</p>
<p>创建SqlCommand对象启用生成XML结果设置的过程。（比如，利用SELECT状态中的FOR XML条款）。把SqlCommand对象与一个链接相联系。 <br />调用SqlCommand对象的ExecuteXmlReader方法，并把结果分配给前向对象XmlTextReader。当不需要任何返回数据的基于XML的验证时，这是应该使用的最快类型的XmlReader对象。 <br />利用XmlTextReader对象的Read方法读取数据。 <br />如何利用存储过程输出参数检索单个行</p>
<p>可以调用一个存储过程，它通过一种称做输出参数的方式可以在单个行中返回检索数据项。下列代码段利用存储的过程检索产品的名称和单价，该产品包含在Northwind数据库中。</p>
<p>void GetProductDetails( int ProductID, <br />                        out string ProductName, out decimal UnitPrice )<br />{<br />  SqlConnection conn = new SqlConnection(<br />        "server=(local);Integrated Security=SSPI;database=Northwind");</p>
<p>// Set up the command object used to execute the stored proc<br />  SqlCommand cmd = new SqlCommand( "DATGetProductDetailsSPOutput", conn );<br />  cmd.CommandType = CommandType.StoredProcedure;<br />  // Establish stored proc parameters.<br />  //  @ProductID int INPUT<br />  //  @ProductName nvarchar(40) OUTPUT<br />  //  @UnitPrice money OUTPUT</p>
<p>// Must explicitly set the direction of output parameters<br />  SqlParameter paramProdID = <br />         cmd.Parameters.Add( "@ProductID", ProductID );<br />  paramProdID.Direction = ParameterDirection.Input;<br />  SqlParameter paramProdName = <br />         cmd.Parameters.Add( "@ProductName", SqlDbType.VarChar, 40 );<br />  paramProdName.Direction = ParameterDirection.Output;<br />  SqlParameter paramUnitPrice = <br />         cmd.Parameters.Add( "@UnitPrice", SqlDbType.Money );<br />  paramUnitPrice.Direction = ParameterDirection.Output;<br />  try<br />  {<br />    conn.Open();<br />    // Use ExecuteNonQuery to run the command. <br />    // Although no rows are returned any mapped output parameters <br />    // (and potentially return values) are populated<br />    cmd.ExecuteNonQuery( );<br />    // Return output parameters from stored proc<br />    ProductName = paramProdName.Value.ToString();<br />    UnitPrice = (decimal)paramUnitPrice.Value;<br />  }<br />  catch<br />  {<br />    throw;<br />  }<br />  finally<br />  {<br />    conn.Close();<br />  }<br />}<br />按下列步骤利用存储的过程输出参数检索单个行：</p>
<p>创建一个SqlCommand对象，并把它与SqlConnection对象相联系。 <br />通过调用SqlCommand’s Parameters集合的Add方法设置存储过程参数。缺省情况下，参数假定为输出参数，所以必须明确设置任何输出参数的方向。 <br />注意 明确设置所有参数的方向是一次很好的练习，包括输入参数。</p>
<p>打开连接。 <br />调用Sqlcommand对象的ExecuteNonQuery方法。它在输出参数（并潜在地带有一个返回值）中。 <br />利用Value属性从合适的SqlParameter对象中检索输出参数。 <br />关闭连接。 <br />上述代码段启用了下列存储过程。</p>
<p>CREATE PROCEDURE DATGetProductDetailsSPOutput<br />@ProductID int,<br />@ProductName nvarchar(40) OUTPUT,<br />@UnitPrice money OUTPUT<br />AS<br />SELECT @ProductName = ProductName, <br />       @UnitPrice = UnitPrice <br />FROM Products <br />WHERE ProductID = @ProductID<br />GO<br />如何利用SqlDataReader检索单个行</p>
<p>可以利用SqlDataReader对象检索单个行，以及来自返回数据流的所需栏的值。这由下列代码说明：</p>
<p>void GetProductDetailsUsingReader( int ProductID, <br />                        out string ProductName, out decimal UnitPrice )<br />{<br />  SqlConnection conn = new SqlConnection(<br />         "server=(local);Integrated Security=SSPI;database=Northwind");</p>
<p>// Set up the command object used to execute the stored proc<br />  SqlCommand cmd = new SqlCommand( "DATGetProductDetailsReader", conn );<br />  cmd.CommandType = CommandType.StoredProcedure;<br />  // Establish stored proc parameters.<br />  //  @ProductID int INPUT</p>
<p>SqlParameter paramProdID = cmd.Parameters.Add( "@ProductID", ProductID );<br />  paramProdID.Direction = ParameterDirection.Input;<br />  try<br />  {<br />    conn.Open();<br />    SqlDataReader reader = cmd.ExecuteReader();<br />    reader.Read(); // Advance to the one and only row</p>
<p>// Return output parameters from returned data stream<br />    ProductName = reader.GetString(0);<br />    UnitPrice = reader.GetDecimal(1);<br />    reader.Close();<br />  }<br />  catch<br />  {<br />    throw;<br />  }<br />  finally<br />  {<br />    conn.Close();<br />  }<br />}<br />按下列步骤返回带有SqlDataReader对象：</p>
<p>建立SqlCommand对象。 <br />打开连接。 <br />调用SqlDReader对象的ExecuteReader对象。 <br />利用SqlDataReader对象的分类的存取程序方法检索输出参数--在这里是GetString和GetDecimal. <br />上述代码段启用了下列存储过程：</p>
<p>CREATE PROCEDURE DATGetProductDetailsReader<br />@ProductID int<br />AS<br />SELECT ProductName, UnitPrice FROM Products<br />WHERE ProductID = @ProductID<br />GO<br />如何利用ExecuteScalar单个项</p>
<p>ExecuteScalar方法是设计成用于返回单个值的访问。在返回多列或多行的访问事件中，ExecuteScalar只返回第一行的第一例。</p>
<p>下列代码说明如何查询某个产品ID的产品名称：</p>
<p>void GetProductNameExecuteScalar( int ProductID, out string ProductName )<br />{<br />  SqlConnection conn = new SqlConnection(<br />         "server=(local);Integrated Security=SSPI;database=northwind");<br />  SqlCommand cmd = new SqlCommand("LookupProductNameScalar", conn );<br />  cmd.CommandType = CommandType.StoredProcedure;</p>
<p>cmd.Parameters.Add("@ProductID", ProductID );<br />  try<br />  {<br />    conn.Open();<br />    ProductName = (string)cmd.ExecuteScalar();<br />  }<br />  catch<br />  {<br />    throw;<br />  }<br />  finally<br />  {<br />    conn.Close();<br />  }<br />}<br />按下列步骤利用Execute Scalar检索单个项：</p>
<p>建立调用存储过程的SqlCommand对象。 <br />打开链接。 <br />调用ExecuteScalar方法，注意该方法返回对象类型。它包含检索的第一列的值，并且必须设计成合适的类型。 <br />关闭链接。<br />上述代码启用了下列存储过程：</p>
<p>CREATE PROCEDURE LookupProductNameScalar<br />@ProductID int<br />AS<br />SELECT TOP 1 ProductName<br />FROM Products<br />WHERE ProductID = @ProductID<br />GO<br />如何利用存储过程输出或返回的参数检索单个项</p>
<p>利用存储过程输出或返回的参数可以查询单个值，下列代码说明了输出参数的使用：</p>
<p>void GetProductNameUsingSPOutput( int ProductID, out string ProductName )<br />{<br />  SqlConnection conn = new SqlConnection(<br />        "server=(local);Integrated Security=SSPI;database=northwind");<br />  SqlCommand cmd = new SqlCommand("LookupProductNameSPOutput", conn );<br />  cmd.CommandType = CommandType.StoredProcedure;</p>
<p>SqlParameter paramProdID = cmd.Parameters.Add("@ProductID", ProductID );<br />  ParamProdID.Direction = ParameterDirection.Input;<br />  SqlParameter paramPN = <br />         cmd.Parameters.Add("@ProductName", SqlDbType.VarChar, 40 );<br />  paramPN.Direction = ParameterDirection.Output;<br />  try<br />  {<br />    conn.Open();<br />    cmd.ExecuteNonQuery();<br />    ProductName = paramPN.Value.ToString();  <br />  }<br />  catch<br />  {<br />    throw;<br />  }<br />  finally<br />  {<br />    conn.Close();<br />  }<br />}<br />按下列步骤利用存储过程的输出参数检索单个值：</p>
<p>创建调用存储过程的SqlCommand对象。 <br />通过把SqlParmeters添加到SqlCommand’s Parameters集合中设置任何输入参数和单个输出参数。 <br />打开链接。 <br />调用SqlCommand对象的Execute NonQuery方法。 <br />关闭链接。 <br />利用输出SqlParameter的Value属性检索输出值。 <br />上述代码使用了下列存储过程：</p>
<p>CREATE PROCEDURE LookupProductNameSPOutput <br />@ProductID int,<br />@ProductName nvarchar(40) OUTPUT<br />AS<br />SELECT @ProductName = ProductName<br />FROM Products<br />WHERE ProductID = @ProductID<br />GO<br />下列代码说明如何利用返回值确定是否存在特殊行。从编码的角度看，这与使用存储过程输出参数相类似，除了需要明确设置到ParameterDirection.ReturnValue的SqlParameter方向。</p>
<p>bool CheckProduct( int ProductID )<br />{<br />  SqlConnection conn = new SqlConnection(<br />       "server=(local);Integrated Security=SSPI;database=northwind");<br />  SqlCommand cmd = new SqlCommand("CheckProductSP", conn );<br />  cmd.CommandType = CommandType.StoredProcedure;</p>
<p>cmd.Parameters.Add("@ProductID", ProductID );<br />  SqlParameter paramRet = <br />         cmd.Parameters.Add("@ProductExists", SqlDbType.Int );<br />  paramRet.Direction = ParameterDirection.ReturnValue;<br />  try<br />  {<br />    conn.Open();<br />    cmd.ExecuteNonQuery();<br />  }<br />  catch<br />  {<br />    throw;<br />  }<br />  finally<br />  {<br />    conn.Close();<br />  }<br />  return (int)paramRet.Value == 1;<br />}<br />按下列步骤，可以利用存储过程返回值检查是否存在特殊行：</p>
<p>建立调用存储过程的SqlCommand对象。 <br />设置包含需要访问的行的主要关键字的输入参数。 <br />设置单个返回值参数。把SqlParameter对象添加到SqlCommand’s Parameter集合中，并设置它到ParameterDireetion.ReturnValue的方面。 <br />打开链接。 <br />调用SqlCommand对象的ExecuteNonQuery的方法. <br />关闭链接。 <br />利用返回值SqlParameter的Value属性检索返回值。 <br />上述代码使用了下列存储过程：</p>
<p>CREATE PROCEDURE CheckProductSP <br />@ProductID int<br />AS<br />IF EXISTS( SELECT ProductID<br />           FROM Products<br />           WHERE ProductID = @ProductID )<br />  return 1<br />ELSE<br />  return 0<br />GO<br />如何利用SqlDataReader检索单个项。</p>
<p>通过调用命令对象的ExecuteReader方法，可以利用SqlDataReader对象获得单个输出值。这需要稍微多一些的代码，因为SqlDataReader Read方法必须调用，然后所需值通过读者存取程序方法得到检索。SqlDataReader对象的使用在下列代码中说明：</p>
<p>bool CheckProductWithReader( int ProductID )<br />{<br />  SqlConnection conn = new SqlConnection(<br />         "server=(local);Integrated Security=SSPI;database=northwind");<br />  SqlCommand cmd = new SqlCommand("CheckProductExistsWithCount", conn );<br />  cmd.CommandType = CommandType.StoredProcedure;</p>
<p>cmd.Parameters.Add("@ProductID", ProductID );<br />  cmd.Parameters["@ProductID"].Direction = ParameterDirection.Input;<br />  try<br />  {<br />    conn.Open();<br />    SqlDataReader reader = cmd.ExecuteReader(<br />                                CommandBehavior.SingleResult );<br />    reader.Read();</p>
<p>bool bRecordExists = reader.GetInt32(0) &gt; 0;<br />    reader.Close();<br />    return bRecordExists;<br />  }<br />  catch<br />  {<br />    throw;<br />  }<br />  finally<br />  {<br />    conn.Close(); <br />  }</p>
<p>}<br />上述代码使用了下列存储过程：</p>
<p>CREATE PROCEDURE CheckProductExistsWithCount <br />@ProductID int<br />AS<br />SELECT COUNT(*) FROM Products<br />WHERE ProductID = @ProductID<br />GO<br />如何编码ADO.NET手工事务</p>
<p>下列代码说明如何利用SQL Server. NET数据供应器提供的事务支持来保护事务的支金转帐操作。该操作在位于同一数据库中的两个帐户之间转移支金。</p>
<p>public void TransferMoney( string toAccount, string fromAccount, decimal amount )<br />{<br />  using ( SqlConnection conn = new SqlConnection(<br />            "server=(local);Integrated Security=SSPI;database=SimpleBank" ) )<br />  {<br />    SqlCommand cmdCredit = new SqlCommand("Credit", conn );<br />    cmdCredit.CommandType = CommandType.StoredProcedure;<br />    cmdCredit.Parameters.Add( new SqlParameter("@AccountNo", toAccount) );<br />    cmdCredit.Parameters.Add( new SqlParameter("@Amount", amount ));</p>
<p>SqlCommand cmdDebit = new SqlCommand("Debit", conn );<br />    cmdDebit.CommandType = CommandType.StoredProcedure;<br />    cmdDebit.Parameters.Add( new SqlParameter("@AccountNo", fromAccount) );<br />    cmdDebit.Parameters.Add( new SqlParameter("@Amount", amount ));</p>
<p>conn.Open();<br />    // Start a new transaction<br />    using ( SqlTransaction trans = conn.BeginTransaction() )<br />    {<br />      // Associate the two command objects with the same transaction<br />      cmdCredit.Transaction = trans;<br />      cmdDebit.Transaction = trans;<br />      try<br />      {<br />        cmdCredit.ExecuteNonQuery();<br />        cmdDebit.ExecuteNonQuery();<br />        // Both commands (credit and debit) were successful<br />        trans.Commit();<br />      }<br />      catch( Exception ex )<br />      {<br />        // transaction failed<br />        trans.Rollback();<br />        // log exception details . . .<br />        throw ex;<br />      }<br />    }<br />  }<br />}<br />如何利用Transact-SQL执行事务</p>
<p>下列存储过程说明了如何在Transact-SQL过程内执行事务的支金转移操作。</p>
<p>CREATE PROCEDURE MoneyTransfer<br />@FromAccount char(20),<br />@ToAccount char(20),<br />@Amount money<br />AS<br />BEGIN TRANSACTION<br />-- PERFORM DEBIT OPERATION<br />UPDATE Accounts<br />SET Balance = Balance - @Amount<br />WHERE AccountNumber = @FromAccount<br />IF @@RowCount = 0<br />BEGIN<br />  RAISERROR('Invalid From Account Number', 11, 1)<br />  GOTO ABORT<br />END<br />DECLARE @Balance money<br />SELECT @Balance = Balance FROM ACCOUNTS<br />WHERE AccountNumber = @FromAccount<br />IF @BALANCE &lt; 0<br />BEGIN<br />  RAISERROR('Insufficient funds', 11, 1)<br />  GOTO ABORT<br />END<br />-- PERFORM CREDIT OPERATION<br />UPDATE Accounts <br />SET Balance = Balance + @Amount <br />WHERE AccountNumber = @ToAccount<br />IF @@RowCount = 0<br />BEGIN<br />  RAISERROR('Invalid To Account Number', 11, 1)<br />  GOTO ABORT<br />END<br />COMMIT TRANSACTION<br />RETURN 0<br />ABORT:<br />  ROLLBACK TRANSACTION<br />GO<br />该存储过程使用BEGIN TRANSACTION， COMMIT TRANSACTION，和ROLLBACK TRANSACTION状态手工控制事务。</p>
<p>如何编码事务性的.NET类</p>
<p>下述例子是三种服务性的NET类，它们配置或用于自动事务。每个类都带有Transaction属性，它的值将决定是否启动新事务流或者对象是否共享即时调用程序的数据流。这些元素一起工作来执行银行支金转移。Transfer类配置有RequiresNew事务属性，而Debit和Credit类配置有Required属性。这样，在运行的时候三个对象共享同一个事务。</p>
<p>using System;<br />using System.EnterpriseServices;</p>
<p>[Transaction(TransactionOption.RequiresNew)]<br />public class Transfer : ServicedComponent<br />{<br />  [AutoComplete]<br />  public void Transfer( string toAccount, <br />                        string fromAccount, decimal amount )<br />  {<br />    try<br />    {<br />      // Perform the debit operation<br />      Debit debit = new Debit();<br />      debit.DebitAccount( fromAccount, amount );<br />      // Perform the credit operation<br />      Credit credit = new Credit();<br />      credit.CreditAccount( toAccount, amount );<br />    }<br />    catch( SqlException sqlex )<br />    {<br />      // Handle and log exception details<br />      // Wrap and propagate the exception<br />      throw new TransferException( "Transfer Failure", sqlex );    <br />    }<br />  }<br />}<br />[Transaction(TransactionOption.Required)]<br />public class Credit : ServicedComponent<br />{<br />  [AutoComplete]<br />  public void CreditAccount( string account, decimal amount )<br />  {<br />    SqlConnection conn = new SqlConnection(<br />            "Server=(local); Integrated Security=SSPI"; database="SimpleBank");<br />    SqlCommand cmd = new SqlCommand("Credit", conn );<br />    cmd.CommandType = CommandType.StoredProcedure;<br />    cmd.Parameters.Add( new SqlParameter("@AccountNo", account) );<br />    cmd.Parameters.Add( new SqlParameter("@Amount", amount ));<br />    try<br />    {<br />      conn.Open();<br />      cmd.ExecuteNonQuery();<br />    }<br />    catch (SqlException sqlex)<br />    {<br />      // Log exception details here<br />      throw; // Propagate exception<br />    }<br />  }<br />}<br />[Transaction(TransactionOption.Required)]<br />public class Debit : ServicedComponent<br />{<br />  public void DebitAccount( string account, decimal amount )<br />  {<br />    SqlConnection conn = new SqlConnection(<br />            "Server=(local); Integrated Security=SSPI"; database="SimpleBank");<br />    SqlCommand cmd = new SqlCommand("Debit", conn );<br />    cmd.CommandType = CommandType.StoredProcedure;<br />    cmd.Parameters.Add( new SqlParameter("@AccountNo", account) );<br />    cmd.Parameters.Add( new SqlParameter("@Amount", amount ));<br />    try<br />    {<br />      conn.Open();<br />      cmd.ExecuteNonQuery();<br />    }<br />    catch (SqlException sqlex)<br />    {<br />      // Log exception details here<br />      throw; // Propagate exception back to caller<br />    }<br />  }<br />}<br />合作者</p>
<p>非常感谢下列撰稿者和审校者：</p>
<p>Bill Vaughn, Mike Pizzo, Doug Rothaus, Kevin White, Blaine Dokter, David Schleifer, Graeme Malcolm（内容专家）, Bernard Chen（西班牙人）, Matt Drucke（协调）和Steve kirk.</p>
<p>读者有什么样的问题、评论和建议？关于本文的反馈信息，请发E-mail至devfdbckmicrosoft.com。</p>
<p>你希望学习并利用.NET的强大功能吗？与微软技术中心的技术专家一起工作，学习开发最佳方案。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 06:09:39</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%96%b9%e6%b3%95/" title="方法">方法</a>, <a href="https://www.iamivan.net/tag/%e5%ad%98%e5%82%a8%e8%bf%87%e7%a8%8b/" title="存储过程">存储过程</a>, <a href="https://www.iamivan.net/tag/%e5%af%b9%e8%b1%a1/" title="对象">对象</a>, <a href="https://www.iamivan.net/tag/%e4%ba%8b%e5%8a%a1/" title="事务">事务</a>, <a href="https://www.iamivan.net/tag/sqlcommand/" title="sqlcommand">sqlcommand</a>, <a href="https://www.iamivan.net/tag/sqlconnection/" title="sqlconnection">sqlconnection</a>, <a href="https://www.iamivan.net/tag/mnc/" title="MNC">MNC</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>.NET 数据访问架构指南(二)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/vbQZNOM.html" rel="bookmark">&period;NET 数据访问架构指南&lpar;一&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				访问|架构|数据 概述:本文提供了在多层.NET应用程序中实施基于ADO.NET的数据访问层的指导原则.其重点是一组通用数据访问任务和方案,并指导你选择最合适的途径和技术(68张打印页). 目录 ADO.NET简介 管理数据库链接 错误处理 性能 通过防火墙建立链接 处理 BLOBs 事务处理 数据分页 简介 如果你在为.NET应用程序设计数据访问层,那么就应该把 Microsoft ADO.NET用作数据访问模型.ADO.NET扩展丰富,并且支持结合松散的数据访问需求.多层Web应用程序及We			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMglN5p.html" rel="bookmark">精华的微软文章&period;NET 数据访问架构指南</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				访问|架构|精华|数据|微软 数据绑定 所有这三个对象都可以作为数据绑定控件的数据源.而DataSet 和 DataTable 可作为更广范围控件的数据源.这是因为DataSet 和 DataTable 实现了(生成Ilist接口)IlistSource接口,而SqlDataReader 实现了Ienumerable接口.许多能进行数据绑定的WinForm控件需要实现了Ilist接口的数据源. 这种不同是因为为每种对象类型设计的场景类型不同.DataSet (它包含 DataTable)是一个丰			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/apXZ4Kb.html" rel="bookmark">&period;NET 数据访问体系结构指南一</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				访问|数据|体系  ADO.NET 引入的主要变化之一是用 DataTable.DataSet.DataAdapter 和 DataReader 对象的组合取代了 ADO Recordset 对象.DataTable 表示单个表中行的集合,在这一方面类似于 Recordset.DataSet 表示 DataTable 对象的集合,同时包括将各种表绑定在一起的关系和约束.实际上,DataSet 是带有内置 XML 支持的.内存中的关系结构. DataSet 的主要特性之一是它不了解可能用来填充它的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M91XloM.html" rel="bookmark">Enterprise Library 2&period;0 Hands On Lab 翻译（2）：数据访问程序块（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				练习2:存储过程和使用程序块更新数据 该练习将示范如何用数据访问应用程序调用存储过程,并使用强类型的DataSet来更新数据. 第一步 打开DataEx2.sln项目,默认的安装路径应该为C:\Program Files\Microsoft Enterprise Library January 2006\labs\cs\Data Access\exercises\ex02\begin,并编译. 第二步 在QuickStarts数据库中添加Categories数据表 运行批处理文件SetUpEx0			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bByWdaz.html" rel="bookmark">CYQ&period;Data 轻量数据访问层（二） 构造数据单元&lpar;上&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				DataTable,你有多丰富: 轻轻的打开Reflector.exe,按下F3搜索,输入DataTable,双击定位,右键,Disassemble之后, 悄悄的点一下最下面的 Expand Methods,再从容的把它copy出来,我们才发现..6000多行的代码 我们常用的DataTable一个类,才用了6000多行代码实现,跟我们以前写的,一个类写到一千多,就觉得有点过了 大巫见小巫啊!     解析: 当然了,不是说一个类代码越多,性能就一定不好.至少我们还是那么多人前拥后挤的在继续使用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQP92Qz.html" rel="bookmark">DNN数据访问策略（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				空处理 每一个数据存取系统都有一个特殊的构造来处理那些没有明确指定的字段值. 在大多数关系数据库管理系统中,这个构造就是众所周知的null值.从应用程序的角度看,在表述层和数据存取层传递null值是一个架构上的挑战.这是因为表述层必须从数据库的特定信息抽象出来:而且,当一个属性值没有明确指定的时候表述层也必须能够表达说明.事实上这相当复杂,.NET Framework的本身的数据类型不能自动的转换从数据库返回的null值(如果你试图直接那样赋值的话将会抛出一个异常).另外,每一个数据存储都有它自			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Ml032qM.html" rel="bookmark">&period;NET轻量级DBHelpers数据访问组件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.摘要 一说到ADO.NET大家可能立刻想到的就是增.删.改.查(CRUD)操作,然后再接就想到项目中的SQLHelper.没错本课分享课阿笨给大家带来的是来源于github上开源的DAO数据库访问组件DBHelpers.如果您对本次分享&lt;.NET轻量级DBHelpers数据访问组件&gt;课程感兴趣的话,那么请跟着阿笨一起学习吧. 废话不多说,直接上干货,我们不生产干货,我们只是干货的搬运工. 二.涉及覆盖的知识点 2.1.原生ADO.NET简单的CRUD(增删改查) Insert.Insert			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjwGW6M.html" rel="bookmark">&lbrack;原创&rsqb;&period;NET 分布式架构开发实战之三 数据访问深入一点的思考</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:[原创].NET 分布式架构开发实战之三 数据访问深入一点的思考 .NET 分布式架构开发实战之三 数据访问深入一点的思考   前言:首先,感谢园子里的朋友对文章的支持,感谢大家,希望本系列的文章能够真正的对大家起到一点帮助的作用.再次感谢大家.   大家也许想问,什么时候出代码,代码一定会出的,我不想一上来就开始抛出一大堆的代码,然后讲解,架构的设计在思考的过程,思考到了,代码也就水到渠成了.   上篇文章讲述在设计之初,Richard所画出的一些草图,本篇对之前的草图做了进一步的思考.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mx2xayz.html" rel="bookmark">《解剖PetShop》之二：PetShop数据访问层数之据库访问设计&lowbar;自学过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				二.PetShop数据访问层之数据库访问设计 在系列一中,我从整体上分析了PetShop的架构设计,并提及了分层的概念.从本部分开始,我将依次对各层进行代码级的分析,以求获得更加细致而深入的理解.在PetShop 4.0中,由于引入了ASP.Net 2.0的一些新特色,所以数据层的内容也更加的广泛和复杂,包括:数据库访问.Messaging.MemberShip.Profile四部分.在系列二中,我将介绍有关数据库访问的设计. 在PetShop中,系统需要处理的数据库对象分为两类:一是数据实体,			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQ4yWz.html" rel="bookmark" class="title">显示以OLE对象存储图片的方法</a>
					<div>
						问题原型: http://expert.csdn.net/Expert/topic/2517/2517974.xml?temp=.4831049 在 ASP 中, 我们经常需要在 Web 页面上显示以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgGgEM.html" rel="bookmark" class="title">实战解析如何通过修改标题来更新网站快照</a>
					<div>
						对于站长判断一个网站的好坏时,其中最为关键的一个因素就是网站快照的新旧了.特别是在友情链接交换时,如果自己的网站快照超出了三天的时间,很少站长愿意与自己交换的.然而面对快照的不更新,大部分站长都会以为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Aw16p.html" rel="bookmark" class="title">asp事件类asplib-eventProvider&period;class&period;asp用于获取ip等</a>
					<div>
						作者真是细致,把这些东西都封装成为class了.有点过了,这些东西可以作成过程或者函数来封装,sub和function也是封装,不一定非要class才可以.您的文件库不一定全部都是class,一些su ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4weANp.html" rel="bookmark" class="title">Android ListView的一个问题</a>
					<div>
						需要的功能很简单,就是一个带checkbox的列表,提交时需要知道用户选择了那些项目,如下图: 使用SimpleAdapter作为数据适配器,重写SimpleAdapter.ViewBinder的方法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7kJyAz.html" rel="bookmark" class="title">Linux2&period;6对新型CPU的支持</a>
					<div>
						文章分析了在 Linux 2.6 中引入的对 Intel CPU 快速系统调用指令 SYSENTER/SYSEXIT 支持的实现.Linux 驱动及内核开发者通过了解快速系统调用指令的机制,可以在自己 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnx32ob.html" rel="bookmark" class="title">photoshop抽出滤镜分离背景</a>
					<div>
						原图 效果图 1. 打开素材图片,复制3个背景层,目的是分别对头发的高光.阴影和中间色做抽出 2. 滤镜-抽出,强制前景,颜色选择为黑色 3. 用对话框中的画笔工具在人身上描绘,不用太考虑细节,因为只 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bal8JJz.html" rel="bookmark" class="title">Windows 8&OpenCurlyDoubleQuote;飞行模式&rdquo;使用方法</a>
					<div>
						之前,当Windows还没有那么复杂的时候,我们需要手动禁用网络连接,从而获取更长的电池续航时间.如今,PC支持的无线网络越来越多,除了Wi-Fi,还有蓝牙连接和移动宽带连接.飞行模式的功用就更加突出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKkgrdb.html" rel="bookmark" class="title">使用神经网络和遗传算法玩转 Flappy Bird</a>
					<div>
						我们创建一个人工智能机器人,它能够学习如何把Flappy Bird这个游戏玩出最高分.这样,我们的小鸟就能安全地飞过一些障碍物了.在最好的情况下,它永远不会死. 欢迎阅读这篇完整的HTML5教程,本文 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBK8J4M.html" rel="bookmark" class="title">Java中窗口关闭事件。</a>
					<div>
						问题描述 Java中窗口关闭事件. 程序代码如下: package com.packageTemp; import java.awt.event.*; import javax.swing.*; im ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NAxoM.html" rel="bookmark" class="title">关于百度Domain命令的一些思考</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 反向链接的重要性,相信不用我说大家 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDWQ8Xp.html" rel="bookmark" class="title">c&plus;&plus;函数调用时拷贝构造函数和析构函数</a>
					<div>
						问题描述 c++函数调用时拷贝构造函数和析构函数 先上代码 class A{ public: A(){cout&lt;&lt;&quot;&quot;构造函数&quot;&quot;&lt;&lt;e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrdYoM.html" rel="bookmark" class="title">使用Solr索引MySQL数据</a>
					<div>
						环境搭建 1.到apache下载solr,地址:http://mirrors.hust.edu.cn/apache/lucene/solr/ 2.解压到某个目录 3.cd into D:\Solr\s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwX4QM.html" rel="bookmark" class="title">自己做低成本的信息分布图</a>
					<div>
						摘要: 你不应该用成本投入多少来判断一个信息图表所能获得群众反映是多少?就好像你无法用成本投入多少来预测网络营销最终带来的效果.我一直坚信一句话,如果你用300块钱去请人制作一 你不应该用成本投入多少 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Nle7z.html" rel="bookmark" class="title">央视网将并入CNTV成子品牌</a>
					<div>
						本报讯 (记者李斌)昨天,记者从中国网络电视台(CNTV)获悉,CNTV与央视网将在5月底合并,两个网站的域名将同时指向CNTV.cn,而央视网将成为CNTV旗下的一个子品牌. 据悉,去年12月28日 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBPv8M.html" rel="bookmark" class="title">c语言-C怎么连接到本地数据库sql server2008</a>
					<div>
						问题描述 C怎么连接到本地数据库sql server2008 我想用C语言连接到local sql server 2008,并且对数据库进行读写操作. 解决方案 到网上查一下好喽,网上很多的. 解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRmgYp.html" rel="bookmark" class="title">java  This的用法</a>
					<div>
						        用类名定义一个变量的时候,定义的应该只是一个引用,外面可以通过这个引用来访问这个类里面的属性和方法,那们类里面是够也应该有一个引用来访问自己的属性和方法纳?呵呵,JAVA提供了一个很好 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvm3dNb.html" rel="bookmark" class="title">如何读取jpg图片中icc配置文件？</a>
					<div>
						问题描述 如果一个jpg图片中内嵌了ICC配置文件,我在如下代码处理之后就丢失了icc配置文件.Imageimg=Image.FromFile(&quot;C:\1.jpg&quot;);...//处 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M943x4b.html" rel="bookmark" class="title">WORD表头有列合并行，ROW&lbrack;&ast;&rsqb;设置行背景色为什么无效</a>
					<div>
						问题描述 如图&quot;这张表格,使用wordtable.Rows[3].Shading.BackgroundPatternColor=Microsoft.Office.Interop.Word.W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDnWnlM.html" rel="bookmark" class="title">国内IaaS应用现状和发展趋势浅析</a>
					<div>
						随着云计算行业技术的快速发展,以及用户对云计算的了解加深,诸多云服务商获得了绝佳的服务契机. 尽管国内IaaS行业大的格局基本已经形成,但我国云计算的发展时间相对较短,实际上并未有真正的&quot;独 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3JALkz.html" rel="bookmark" class="title">我问一个笼统一点的问题&comma;关于ASP&period;net网站开发环境的&excl;请大家来看看解答一下&period;</a>
					<div>
						问题描述 突然发现现在有不少.net的网站和实例,在编写方法上来讲,应都不是依靠用vs2003或者vs2005的开发环境中写出的.按说在web规划,设计,切片,布局做完以后应该就是添加动态内容.编写程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK51dOp.html" rel="bookmark" class="title">类的生命周期回顾篇</a>
					<div>
						一.JAVA虚拟机和JAVA程序的生命周期 JAVA虚拟机的生命周期和JAVA程序的生命周期一致,当我们在命令行中敲入java命令运行java程序时,java虚拟机进程启动,程序运行,当程序终止时,则 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3J3xNz.html" rel="bookmark" class="title">请教怎么防止支付后网银或者支付宝多次回发</a>
					<div>
						问题描述 最近在做支付,但是遇到了一个问题,不管是支付宝还是其他网银支付,付款成功后,他们都会发多次结果,支付宝和银联或招行支付,都要连续发5次支付结果来,然后我后台就处理五次支付结果,这样照成了我多 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba6nXPM.html" rel="bookmark" class="title">如何把关键词上百度第一页</a>
					<div>
						第一.内容尽量原创或者伪原创.这是个老生常谈的话题了,大家都知道内容的重要性,但很多朋友还是喜欢偷懒,只愿意采集.正所谓天道酬勤,你付出了多少,收获也会有多少.而且,SEO的工作,排除你的一些核心资源 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0N7vAz.html" rel="bookmark" class="title">SQL语句详解 MySQL update的正确用法&lowbar;Mysql</a>
					<div>
						单表的MySQL UPDATE语句: UPDATE [LOW_PRIORITY] [IGNORE] tbl_name SET col_name1=expr1 [, col_name2=expr2 .. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3ZvP0z.html" rel="bookmark" class="title">有关使用co个性域名半年的总结</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 我们最模板旗下的ecshop模板网 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Z44kz.html" rel="bookmark" class="title">请问哪有asp&period;net2&period;0的入门教程&comma;从0开始那种&comma;最好有实例&comma;本人新学&comma;谢谢 &excl;</a>
					<div>
						问题描述 RT 解决方案 解决方案二:去微软的webcast看视频吧解决方案三:如果楼主e文听力不错,可以到微软的网站去找相关的视频,讲得非常非常好,可以让你学得很快,而且很精通的那种.解决方案四:h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zenWQNb.html" rel="bookmark" class="title">使用Vagrant 构建开发环境</a>
					<div>
						最近vagrant比较流行,它的主要作用简言之就是打包一份已经装好的系统,打包好的系统在各平台通用.特别是对于一个比较复杂的开发环境,新换一台电脑,新换一个工作,必须在重新搭建环境,这种事情搞起来还是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQWo9wp.html" rel="bookmark" class="title">帕伯利森韦校：公关思维或像互联网思维一样时髦</a>
					<div>
						帕伯利森公关CEO韦校 人们对公关的理解和说法,可以说是众说纷纭,各显起见.从理论上来说,http://www.aliyun.com/zixun/aggregation/30722.html&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrvR4vM.html" rel="bookmark" class="title">oracle修改属性字段</a>
					<div>
						问题描述 原表是整形,现在要改成带两位小数有个oracle问题我要修改一个字段的属性用脚本原来是:price number现在改成:price number(10,2)原表有数据首先我必须要备份表吧. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOk2W9z.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;量子密钥&rdquo;：互联网信息安全&OpenCurlyDoubleQuote;黑科技&rdquo;</a>
					<div>
						第三届世界互联网大会迎来行业盛事--世界互联网领先科技成果发布.成果发布活动上,中国科学院量子信息与量子科技前沿卓越创新中心主任潘建伟介绍,量子通讯将成为未来互联网信息安全的中坚力量. 潘建伟介绍,在 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.068 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
